diff -ur nagios-4.0.20130107/base/checks.c nagios-4.0.20130107.withmacros//base/checks.c
--- nagios-4.0.20130107/base/checks.c	2013-01-11 01:23:09.000000000 +0000
+++ nagios-4.0.20130107.withmacros//base/checks.c	2013-01-14 08:52:03.000000000 +0000
@@ -311,6 +311,13 @@
 	/* update check statistics */
 	update_check_stats((scheduled_check == TRUE) ? ACTIVE_SCHEDULED_SERVICE_CHECK_STATS : ACTIVE_ONDEMAND_SERVICE_CHECK_STATS, start_time.tv_sec);
 
+	/* TODO: Grab only the macros defined in the command definition - this currently forces the first 3 to prove it works*/
+	int free_macro = FALSE;
+	grab_macrox_value_r(&mac, 0, NULL, NULL, &mac.x[0], &free_macro);
+	grab_macrox_value_r(&mac, 1, NULL, NULL, &mac.x[1], &free_macro);
+	grab_macrox_value_r(&mac, 2, NULL, NULL, &mac.x[2], &free_macro);
+	//printf("Setting cmd=%s, %s, %s, %s\n", processed_command, mac.x[0], mac.x[1], mac.x[2]);
+
 	/* paw off the check to a worker to run */
 	runchk_result = wproc_run_check(cr, processed_command, &mac);
 	if (runchk_result == ERROR) {
@@ -2466,6 +2473,13 @@
 	update_check_stats((scheduled_check == TRUE) ? ACTIVE_SCHEDULED_HOST_CHECK_STATS : ACTIVE_ONDEMAND_HOST_CHECK_STATS, start_time.tv_sec);
 	update_check_stats(PARALLEL_HOST_CHECK_STATS, start_time.tv_sec);
 
+	/* TODO: Grab only the macros defined in the command definition - this currently forces the first 3 to prove it works*/
+	int free_macro = FALSE;
+	grab_macrox_value_r(&mac, 0, NULL, NULL, &mac.x[0], &free_macro);
+	grab_macrox_value_r(&mac, 1, NULL, NULL, &mac.x[1], &free_macro);
+	grab_macrox_value_r(&mac, 2, NULL, NULL, &mac.x[2], &free_macro);
+	//printf("Setting cmd=%s, %s, %s, %s\n", processed_command, mac.x[0], mac.x[1], mac.x[2]);
+
 	runchk_result = wproc_run_check(cr, processed_command, &mac);
 	if (runchk_result == ERROR) {
 		logit(NSLOG_RUNTIME_ERROR, TRUE, "Unable to run check for host '%s'\n", hst->name);
diff -ur nagios-4.0.20130107/base/workers.c nagios-4.0.20130107.withmacros//base/workers.c
--- nagios-4.0.20130107/base/workers.c	2012-12-24 15:29:58.000000000 +0000
+++ nagios-4.0.20130107.withmacros//base/workers.c	2013-01-14 08:57:22.000000000 +0000
@@ -911,6 +911,11 @@
 	if (!kvvec_init(&kvv, 4))	/* job_id, type, command and timeout */
 		return ERROR;
 
+	/* TODO: Testing specific envvars get passed to workers. Need to change to be based on if macro is set */
+	kvvec_addkv(&kvv, "env", (char *)mkstr("%s=%s", "NAGIOS_HOSTNAME", mac->x[0]));
+	kvvec_addkv(&kvv, "env", (char *)mkstr("%s=%s", "NAGIOS_HOSTALIAS", mac->x[1]));
+	kvvec_addkv(&kvv, "env", (char *)mkstr("%s=%s", "NAGIOS_HOSTADDRESS", mac->x[2]));
+	kvvec_addkv(&kvv, "env", (char *)mkstr("%s=%s", "NAGIOS_TEST_VAR", mac->host_ptr->address));
 	kvvec_addkv(&kvv, "job_id", (char *)mkstr("%d", job->id));
 	kvvec_addkv(&kvv, "type", (char *)mkstr("%d", job->type));
 	kvvec_addkv(&kvv, "command", job->command);
diff -ur nagios-4.0.20130107/lib/worker.c nagios-4.0.20130107.withmacros//lib/worker.c
--- nagios-4.0.20130107/lib/worker.c	2013-01-11 01:23:10.000000000 +0000
+++ nagios-4.0.20130107.withmacros//lib/worker.c	2013-01-14 08:59:23.000000000 +0000
@@ -254,6 +254,9 @@
 		struct key_value *kv = &cp->request->kv[i];
 		/* skip environment macros */
 		if (kv->key_len == 3 && !strcmp(kv->key, "env")) {
+			char *var = strtok(kv->value, "=");
+			//printf("Unsetting var %s\n", var);
+			unsetenv(var);
 			continue;
 		}
 		kvvec_addkv_wlen(&resp, kv->key, kv->key_len, kv->value, kv->value_len);
@@ -500,6 +503,12 @@
 			cp->timeout = (unsigned int)strtoul(value, &endptr, 0);
 			continue;
 		}
+		if (!strcmp(key, "env")) {
+			//printf("Got env: %s\n", value);
+			// TODO: Need to use library routine in utils.c for OSes that do not support putenv
+			putenv(value);
+			continue;
+		}
 	}
 
 	/* jobs without a timeout get a default of 60 seconds. */
 configure: failed program was:
